<?php
class ContactForm {

	private $pagesObj;

	function __construct() {

		require_once(YCF_FILES."YcfDefaultValues.php");
		require_once(YCF_CLASSES."YcfFunctions.php");
		require_once(YCF_FILES."YCFContactFormAdminPost.php");
		require_once(YCF_CLASSES_FORM."YcfForm.php");
		require_once(YCF_CLASSES."YCFContactFormInstaller.php");
		require_once(YCF_CLASSES."YcfContactFormData.php");
		require_once(YCF_CLASSES."YcfFunctions.php");
		require_once(YCF_CSS_PATH."ycfStyles.php");
		require_once(YCF_JAVASCRIPT_PATH."ycfJavascript.php");
		require_once(YCF_FILES."YcfActions.php");
		require_once(YCF_FILES."YcfAjax.php");
		require_once(YCF_FILES."YcfSendEmail.php");
		require_once(YCF_CLASSES."YcfPages.php");

		$pagesObj =  new YcfPages();
		$expanderData = new YcfContactFormData();
		$functionsObj = new YcfFunctions();
		$formObj = new YcfForm();

		$this->pagesObj = $pagesObj;
		$pagesObj->expanderDataObj = $expanderData;
		$pagesObj->functionsObj = $functionsObj;
		$pagesObj->formObj = $formObj;
		
		$this->actions();
	}

	public function activate() {

		YCFContactFormInstaller::install();
	}

	public function uninstall() {

		YCFContactFormInstaller::uninstall();
	}

	public function shortcode() {

		require_once(YCF_CLASSES."YcfShortCode.php");
		$shortCodeObj = new YcfShortCode();
	}

	public function enqueueScripts() {
		
	}

	public function ycfMainMenu() {
		
		$this->pagesObj->mainPage();
	}

	public function addNewButton() {

		$this->pagesObj->addNewButtons();
	}

	public function addNewPage() {
		
		$this->pagesObj->addNewPage();
	}

	public function ycfAdminMenu() {

		add_menu_page("Contact Form", "Contact Form", "manage_options","YcfMenu",array($this, 'ycfMainMenu'));
		add_submenu_page("YcfMenu","Add New","Add New","manage_options",'addNewForm', array($this,'addNewPage'));
		add_submenu_page("YcfMenu","Add New button","Add New button","manage_options",'button', array($this,'addNewButton'));
	}

	public function ycfHead() {
		if(isset($_POST) && !empty($_POST)) {
			var_dump($_POST);
			die();
		}
	}

	public function actions() {
		$actions = new YcfActions();
		add_action("admin_menu", array($this, 'ycfAdminMenu'));
		add_action('wp_head',  array($this, 'shortcode'));
		add_action('wp_head',  array($this, 'ycfHead'));
		register_activation_hook(YCF_PATH.YCF_MAIN_FILE,  array($this, 'activate'));
		register_uninstall_hook(YCF_PATH.YCF_MAIN_FILE,  array('YcfMenu', 'uninstall'));
		add_action('admin_post_update_data', array('DataProcessing', 'expanderUpdateData'));
	}
}